//
//  TestPerson.m
//  Person
//
//  Created by Ph(i)Nk 0 on Fri May 17 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import "TestPerson.h"
#import "Person.h"


@implementation TestPerson

- (void) setUp
{
	person = [[Person alloc] init];
}


- (void) tearDown
{
	[person release];
}


- (void) testFullName
{
	[person setFirstName:@"Pablo"];
	[person setLastName:@"Picasso"];

	should ([[person fullName] isEqual:@"Pablo Picasso"]);
}


- (void) testEmptyFirstName
{
	[person setFirstName:@""];
	[person setLastName:@"Picasso"];
	shouldBeEqual ([person fullName], [person lastName]);
}


- (void) testNilFirstName
{
	[person setFirstName:nil];
	[person setLastName:@"Picasso"];
	shouldBeEqual ([person firstName], @"");
	shouldBeEqual ([person fullName], [person lastName]);
}


- (void) testEmptyLastName
{
	[person setFirstName:@"Pablo"];
	[person setLastName:@""];
	shouldBeEqual ([person fullName], [person firstName]);
}


- (void) testNilLastName
{
	[person setFirstName:@"Pablo"];
	[person setLastName:nil];
	shouldBeEqual ([person lastName], @"");
	shouldBeEqual ([person fullName], [person firstName]);
}
@end
