/*$Id: SenTestContinueOrRaiseTesting.m,v 1.5 2001/11/22 13:13:52 phink Exp $*/

// Copyright (c) 1997-2001, Sen:te (Sente SA).  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import "SenTestContinueOrRaiseTesting.h"
#import <SenFoundation/SenFoundation.h>

@interface SenFailureTest: SenTestCase
@end


@implementation SenFailureTest
- (void) failThrice
{
   shouldBeEqual (@"a", @"A");
   shouldBeEqual (@"a", @"A");
   shouldRaise ([@"a" isEqualToString:@"x"]);
}
@end


@implementation SenTestContinueOrRaiseTesting
- (void) setUp
{
    failThrice = [[SenFailureTest testCaseWithSelector:@selector(failThrice)] retain];
}


- (void) tearDown
{
    RELEASE (failThrice);
}


- (void) testRaiseAfterFailure
{
    [failThrice raiseAfterFailure];
    should ([[self silentRunForTest:failThrice] failureCount] == 1);
}


- (void) testContinueAfterFailure
{
    [failThrice continueAfterFailure];
    should ([[self silentRunForTest:failThrice] failureCount] == 3);
}
@end
