/*$Id: SenTestErrorTesting.m,v 1.7 2001/11/22 13:13:52 phink Exp $*/

// Copyright (c) 1997-2001, Sen:te (Sente SA).  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import "SenTestErrorTesting.h"
#import <SenFoundation/SenFoundation.h>

@interface SenErrorTest: SenTestCase
@end


@implementation SenErrorTest
- (void) error
{
    [NSException raise:NSGenericException format:@"A voluntary error"];
    [NSException raise:NSGenericException format:@"Another voluntary error"];
}
@end


@implementation SenTestErrorTesting
- (void) setUp
{
    testRun = [[self silentRunForTest:[SenErrorTest testCaseWithSelector:@selector(error)]] retain];
}


- (void) tearDown
{
    RELEASE (testRun);
}


- (void) testUnfailureCount
{
    should ([testRun unexpectedExceptionCount] == 1);
}


- (void) testExpectedFailureCount
{
    should ([testRun failureCount] == 0);
}


- (void) testSuccess
{
    shouldnt ([testRun hasSucceeded]);
}
@end
