/*$Id: SenTestMacroTesting.m,v 1.5 2001/11/22 13:13:52 phink Exp $*/

// Copyright (c) 1997-2001, Sen:te (Sente SA).  All rights reserved.
//
// Use of this source code is governed by the license in OpenSourceLicense.html
// found in this distribution and at http://www.sente.ch/software/ ,  where the
// original version of this source code can also be found.
// This notice may not be removed from this file.

#import "SenTestMacroTesting.h"
#import <SenFoundation/SenFoundation.h>

@implementation SenTestMacroTesting
- (SenTestRun *) silentRunForTest:(SenTest *) aTest
{
    SenTestRun *testRun;
    [SenTestObserver suspendObservation];
    testRun = [aTest run];
    [SenTestObserver resumeObservation];
    return testRun;
}


- (Class) testedClass
{
    return Nil;
}


- (void) setUp
{
    passedRun = [[self silentRunForTest:[[self testedClass] testCaseWithSelector:@selector(pass)]] retain];
    failedRun = [[self silentRunForTest:[[self testedClass] testCaseWithSelector:@selector(fail)]] retain];
}


- (void) tearDown
{
    RELEASE (passedRun);
    RELEASE (failedRun);
}
@end
